Skip site navigation (1)Skip section navigation (2)
Date:      Fri, 4 Oct 2013 13:27:19 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r256049 - user/pho/stress2/misc
Message-ID:  <201310041327.r94DRJwq067472@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Fri Oct  4 13:27:19 2013
New Revision: 256049
URL: http://svnweb.freebsd.org/changeset/base/256049

Log:
  Added regression test for r234131.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/dup2.sh   (contents, props changed)

Added: user/pho/stress2/misc/dup2.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/dup2.sh	Fri Oct  4 13:27:19 2013	(r256049)
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Regression test for r234131.
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/dup2.c
+cc -o dup2  -Wall -Wextra dup2.c || exit 1
+rm -f dup2.c
+cd $odir
+
+/tmp/dup2 || echo FAIL
+
+rm -f /tmp/dup2
+exit
+
+EOF
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+int
+main(void)
+{
+	int error, fd2, i;
+
+	error = 0;
+	for (i = 0; i < 10000; i++) {
+		fd2 = arc4random() % 1000000;
+		if (dup2(1, fd2) != 0) {
+			if (errno != EBADF) {
+				warn("dup2(2, %d)", fd2);
+				error = 1;
+				break;
+			}
+		} else
+			close(fd2);
+	}
+
+	return (error);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201310041327.r94DRJwq067472>